﻿IncludeFile "OWire_Module.pbi"

EnableExplicit


#SP_Pin_DTR = 1
#SP_Pin_RTS = 2
#SP_Pin_TXD = 4

#SP_Pin_RI  = 0
#SP_Pin_DCD = 1
#SP_Pin_DSR = 2
#SP_Pin_CTS = 3

ProcedureDLL OW_GetMode()
  ProcedureReturn OWire::OW_GetMode()
EndProcedure

ProcedureDLL OW_SetMode(Mode) ; Режим См. констранты #OW_Mode_xxxx.
  ProcedureReturn OWire::OW_SetMode(Mode)
EndProcedure

ProcedureDLL OW_GetLastError() ; Код ошибки (см. константы #OW_Err_xxxx)
  ProcedureReturn OWire::OW_GetLastError()
EndProcedure

ProcedureDLL OW_OpenPort(ComPort.s, Port) ; Открытие порта.
  If Port=-1 : Port=#PB_Any : EndIf
  ProcedureReturn OWire::OW_OpenPort(ComPort, Port)
EndProcedure

ProcedureDLL OW_ClosePort(Port) ; Закрытие порта.
  ProcedureReturn OWire::OW_ClosePort(Port)
EndProcedure

ProcedureDLL OW_Reset(Port)   ; Сброс датчика.
  ProcedureReturn OWire::OW_Reset(Port)   ; Сброс датчика.
EndProcedure

ProcedureDLL.a OW_ReadByte(Port) ; Чтение байта.
  ProcedureReturn OWire::OW_ByteRW($FF, Port) ; Чтение/запись байта.
EndProcedure

ProcedureDLL.a OW_WriteByte(Byte.a, Port) ; Запись байта.
  ProcedureReturn OWire::OW_ByteRW(Byte, Port) ; Чтение/запись байта.
EndProcedure

ProcedureDLL OW_ReadMultiByte(*Buff.OWire::OW_Buff, Count, Port) ; Чтение массива байт.
  ProcedureReturn OWire::OW_ReadMultiByte(*Buff, Count, Port)
EndProcedure

ProcedureDLL OW_WriteMultiByte(*Buff.OWire::OW_Buff, Count, Port) ; Запись массива байт.
  ProcedureReturn OWire::OW_WriteMultiByte(*Buff, Count, Port)
EndProcedure

ProcedureDLL.a OW_GetCRC(*Buff, Count) ; Вычислене контрольной суммы.
  ProcedureReturn OWire::OW_GetCRC(*Buff, Count)
EndProcedure

; Датчик передает 8-битный код семейства (10h для DS18S20 и 28h для DS18B20),
; затем 48-битный серийный номер, а затем 8-битную CRC для проверки правильности принятой информации.
ProcedureDLL OW_ReadROM(*Info.OWire::OW_SN, Port)
  ProcedureReturn OWire::OW_ReadROM(*Info, Port)
EndProcedure

; Эта процедура позволяет адресовать на шине конкретный датчик температуры.
; Необходимо передать 64-битный код датчика (считанный процедурой ReadROM()),
; и только тот, который имеет такой код, будет «откликаться» до следующего импульса сброса.
ProcedureDLL OW_SelectROM(*Info.OWire::OW_SN, Port)
  ProcedureReturn OWire::OW_SelectROM(*Info, Port)
EndProcedure

; Вызов процедуры позволит пропустить процедуру сравнения серийного номера
; и тем самым сэкономить время в системах, где на шине имеется всего одно устройство.
ProcedureDLL OW_SkipROM(Port)
  ProcedureReturn OWire::OW_SkipROM(Port)
EndProcedure

; Сброс поиска.
ProcedureDLL OW_SearchROM_Reset()
   ProcedureReturn OWire::OW_SearchROM_Reset()
EndProcedure

 ; Перечисление устройст. Вернет #True если еще есть устройства.
ProcedureDLL OW_SearchROM_Enum(*Sensor.OWire::OW_SN, Port)
  ProcedureReturn OWire::OW_SearchROM_Enum(*Sensor.OWire::OW_SN, Port)
EndProcedure

; Сброс поиска датчиков у которых результат последнего измерения температуры
; выходит за предустановленные пределы TH и TL.
ProcedureDLL OW_SearchAlarm_Reset()
  ProcedureReturn OWire::OW_SearchAlarm_Reset()
EndProcedure

 ; Перечисление устройст. Вернет #True если еще есть устройства.
ProcedureDLL OW_SearchAlarm_Enum(*Sensor.OWire::OW_SN, Port)
  ProcedureReturn OWire::OW_SearchAlarm_Enum(*Sensor.OWire::OW_SN, Port)
EndProcedure

; Чтение данных из промежуточного ОЗУ датчика.
ProcedureDLL OW_ReadRAM(*Info.OWire::OW_RAM, Port)
  ProcedureReturn OWire::OW_ReadRAM(*Info, Port)
EndProcedure

; Запись данных в промежуточное ОЗУ датчика.
ProcedureDLL OW_WriteRAM(*Info.OWire::OW_Buff, Port)
  ProcedureReturn OWire::OW_WriteRAM(*Info, Port)
EndProcedure

; Копирование данных из промежуточного ОЗУ в энергонезависимую память датчика.
; Эта операция требует около 10мс.
ProcedureDLL OW_CopyRAM(Port)
  ProcedureReturn OWire::OW_CopyRAM(Port)
EndProcedure

; Запуск процесса преобразования температуры.
ProcedureDLL OW_ConvertT(Port)
  ProcedureReturn OWire::OW_ConvertT(0, Port)
EndProcedure

; Эта процедура действует обратным образом по отношению к процедуре OW_CopyRAM(),
; т.е. она позволяет считать байты TH и TL из энергонезависимой памяти в промежуточное ОЗУ.
ProcedureDLL OW_Recall(Port)
  ProcedureReturn OWire::OW_Recall(Port)
EndProcedure

; Проверка, использует ли 1-Wire устройство паразитное питание.
ProcedureDLL OW_ReadPowerSupply(Port)
  ProcedureReturn OWire::OW_ReadPowerSupply(Port)
EndProcedure


ProcedureDLL SP_PortID(Port) ; Идентификатор порта.
  ProcedureReturn OWire::OW_PortID(Port)
EndProcedure

ProcedureDLL SP_CountInBytes(Port) ; Количество байт в приемном буфере порта.
  Protected Result=-1
  
  If Port=OWire::#OW_PortOnly
    Port=OWire::OW_GetPortDefID()
  EndIf
  
  If IsSerialPort(Port)
    Result=AvailableSerialPortInput(Port)
    OWire::OW_SetLastError(OWire::#OW_Err_OK)
  Else
    OWire::OW_SetLastError(OWire::#OW_Err_Port)
  EndIf
  
  ProcedureReturn Result
EndProcedure

ProcedureDLL.a SP_ReadByte(Port) ; Чтение байта из порта.
  Protected Result.a=0
  
  If Port=OWire::#OW_PortOnly
    Port=OWire::OW_GetPortDefID()
  EndIf
  
  If IsSerialPort(Port)
    If AvailableSerialPortInput(Port)>0
      If ReadSerialPortData(Port, @Result, 1)=1
        OWire::OW_SetLastError(OWire::#OW_Err_OK)
      Else
        Goto m1
      EndIf
    Else
      m1:
      OWire::OW_SetLastError(OWire::#OW_Err_NoData)
    EndIf
  Else
    OWire::OW_SetLastError(OWire::#OW_Err_Port)
  EndIf
  
  ProcedureReturn Result
EndProcedure

ProcedureDLL SP_WriteByte(Byte.a, Port) ; Запись байта в порт.
  Protected Result=0
  
  If Port=OWire::#OW_PortOnly
    Port=OWire::OW_GetPortDefID()
  EndIf
  
  If IsSerialPort(Port)
    Result=WriteSerialPortData(Port, @Byte, 1)
    If Result=1
      OWire::OW_SetLastError(OWire::#OW_Err_OK)
    Else
      OWire::OW_SetLastError(OWire::#OW_Err_IO)
    EndIf
  Else
    OWire::OW_SetLastError(OWire::#OW_Err_Port)
  EndIf
  ProcedureReturn Result
EndProcedure

ProcedureDLL SP_GetControlPin(Pin, Port) ; Чтение состояния управляющих входов.
  Protected Result=0, Err=#False
  
  If Port=OWire::#OW_PortOnly
    Port=OWire::OW_GetPortDefID()
  EndIf
  
  If IsSerialPort(Port)
    
    Select Pin
      Case #SP_Pin_RI  : Pin=#PB_SerialPort_RI
      Case #SP_Pin_DCD : Pin=#PB_SerialPort_DCD
      Case #SP_Pin_DSR : Pin=#PB_SerialPort_DSR
      Case #SP_Pin_CTS : Pin=#PB_SerialPort_CTS
      Default : Err=#True
    EndSelect
    
    If Err=#False
      Result = GetSerialPortStatus(Port, Pin)
      OWire::OW_SetLastError(OWire::#OW_Err_OK)
    Else
      OWire::OW_SetLastError(OWire::#OW_Err_BadParam)
    EndIf
    
  Else
    OWire::OW_SetLastError(OWire::#OW_Err_Port)
  EndIf
  
  ProcedureReturn Result
EndProcedure

ProcedureDLL SP_SetControlPin(Pin, Value.a, Port) ; Изменение состояния управляющих выходов.
  Protected Flag.l=0, Result = #False
  
  If Port=OWire::#OW_PortOnly
    Port=OWire::OW_GetPortDefID()
  EndIf
  
  If IsSerialPort(Port)
    
    Value = Bool(Value)
    
    If Pin & #SP_Pin_DTR
      SetSerialPortStatus(Port, #PB_SerialPort_DTR, Value)
      Flag | %0000000000010000
    EndIf
    
    If Pin & #SP_Pin_RTS
      SetSerialPortStatus(Port, #PB_SerialPort_RTS, Value)
      Flag | %0001000000000000
    EndIf
    
    If Pin & #SP_Pin_TXD
      SetSerialPortStatus(Port, #PB_SerialPort_TXD, Value)
    EndIf
    
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      If Flag
        Protected dcb.DCB, PortID
        PortID = SerialPortID(Port)
        If GetCommState_(PortID, @dcb)
          dcb\fbits & ~%0010000000100000
          If Value
            dcb\fbits |  Flag
          Else
            dcb\fbits & ~Flag
          EndIf
          SetCommState_(PortID, @dcb)
        EndIf
      EndIf
    CompilerEndIf
    
    If Flag Or Pin & #SP_Pin_TXD
      Result = #True
      OWire::OW_SetLastError(OWire::#OW_Err_OK)
    Else
      OWire::OW_SetLastError(OWire::#OW_Err_BadParam)
    EndIf
  
  Else
    OWire::OW_SetLastError(OWire::#OW_Err_Port)
  EndIf
  
  ProcedureReturn Result
EndProcedure


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; ExecutableFormat = Shared Dll
; Folding = ------
; EnableThread
; Executable = ..\OWire_Module.dll
; EnableBuildCount = 36
; IncludeVersionInfo
; VersionField0 = 1.2.0.%BUILDCOUNT
; VersionField1 = 1.2.0.0
; VersionField2 = pure-basic@yandex.ru
; VersionField3 = OWire Module
; VersionField4 = 1.2.0.%BUILDCOUNT
; VersionField5 = 1.2
; VersionField6 =   1-Wire 
; VersionField7 = OWire Module
; VersionField8 = %EXECUTABLE
; VersionField11 = x86
; VersionField12 = multi thread mode
; VersionField13 = pure-basic@yandex.ru
; VersionField15 = VOS_NT_WINDOWS32
; VersionField16 = VFT_DLL
; VersionField17 = 0419 Russian