unit OWire_Module;
 
interface

const


//   (  OW_GetLastErr()).
OW_Err_OK       = 0; //  .
OW_Err_Port     = 1; //    ( OW_OpenPort() -   ).
OW_Err_NoDevice = 2; //   1-Wire .
OW_Err_IO       = 3; //    .
OW_Err_BaudRate = 4; //     .
OW_Err_Search   = 5; //         1-Wire   .
OW_Err_BadParam = 6; //  .
OW_Err_NoData   = 7; //  .

//   .
OW_Mode_CPU_MinUsage = 1; //    .
OW_Mode_Invert       = 2; //    DTR  RTS.
OW_Mode_NoControlPin = 4; //       DTR  RTS.

//    ( SP_SetControlPin()).
SP_Pin_DTR = 1;
SP_Pin_RTS = 2;
SP_Pin_TXD = 4;
//     ( SP_GetControlPin()).
SP_Pin_RI  = 0;
SP_Pin_DCD = 1;
SP_Pin_DSR = 2;
SP_Pin_CTS = 3;


type

OW_RAM = packed record  //   DS18B20.
  L_Termo:   Byte;   //   
  H_Termo:   Byte;   //   
  Max_Termo: Byte;   //   
  Min_Termo: Byte;   //   
  Config:    Byte;   //  
  x: array [1..3] of Byte; //  3  (   )
  CRC:       Byte;   //  
end;

OW_Write_RAM = packed record
  Max_Termo: Byte;   //   
  Min_Termo: Byte;   //   
  Config:    Byte;   //  
end;

OW_SN = packed record  //  .
  DevType:   Byte;   //   ( ).
  Number: array [1..6] of Byte; //  .
  CRC:       Byte;   //  .
end;

// . .  OW_Mode_xxxx.
function OW_GetMode() : Integer; stdcall; external 'OWire_Module.dll';
function OW_SetMode(Mode:Integer) : Integer; stdcall; external 'OWire_Module.dll';
//   (.  OW_Err_xxxx  SP_Err_xxxx).
function OW_GetLastError() : Integer; stdcall; external 'OWire_Module.dll';
//   .
function OW_ClosePort(Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//   .
function OW_OpenPort(ComPort:String; Port:Integer=0): Integer; stdcall; external 'OWire_Module.dll';
//  1-Wire .
function OW_Reset(Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//  .
function OW_ReadByte(Port:Integer=0): Byte; stdcall; external 'OWire_Module.dll';
//  .
function OW_WriteByte(Byte:Byte; Port:Integer=0): Byte; stdcall; external 'OWire_Module.dll';
//   .
function OW_GetCRC(Buff:Pointer; Count:Integer): Byte; stdcall; external 'OWire_Module.dll';
//   .
function OW_ReadMultiByte(Buff:Pointer; Count:Integer; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//   .
function OW_WriteMultiByte(Buff:Pointer; Count:Integer; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
// 1-Wire   8-   (10h  DS18S20  28h  DS18B20),
//  48-  ,   8- CRC     .
function OW_ReadROM(var Info:OW_SN; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//        1-Wire .
//   64-  1-Wire    ,
//    ,      .
function OW_SelectROM(var Info:OW_SN; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//    .
function OW_SkipROM(Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//   1-Wire .
function OW_SearchROM_Reset(): Integer; stdcall; external 'OWire_Module.dll';
//  .   0    .
function OW_SearchROM_Enum(var Sensor:OW_SN; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//         
//     TH  TL.
function OW_SearchAlarm_Reset(): Integer; stdcall; external 'OWire_Module.dll';
//  .   0    .
function OW_SearchAlarm_Enum(var Sensor:OW_SN; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//       DS18B20.
function OW_ReadRAM(var Info:OW_RAM; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//       DS18B20.
function OW_WriteRAM(var Info:OW_Write_RAM; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//         .
//    10.
function OW_CopyRAM(Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//    .
function OW_ConvertT(Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//          OW_CopyRAM(),
// ..     TH  TL      .
function OW_Recall(Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
// ,   1-Wire   .
// 1 -    0  .
function OW_ReadPowerSupply(Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';
//    .
function SP_PortID(Port:Integer=0): Integer; stdcall; external 'OWire_Module.dll';
//        .
function SP_CountInBytes(Port:Integer=0): Integer; stdcall; external 'OWire_Module.dll';
//    .
function SP_ReadByte(Port:Integer=0): Byte; stdcall; external 'OWire_Module.dll';
//    .
function SP_WriteByte(Byte:Byte; Port:Integer=0): Integer; stdcall; external 'OWire_Module.dll';
//    .
function SP_GetControlPin(Pin:Integer; Port:Integer=0): Integer; stdcall; external 'OWire_Module.dll';
function SP_SetControlPin(Pin:Integer; Value:Boolean; Port:Integer=0): Boolean; stdcall; external 'OWire_Module.dll';

implementation

end.
