﻿
XIncludeFile "OWire_Module_dll.pbi"

Global Dim Com(4)

Procedure ComIn() ; Вызывается по таймеру (каждые 400 мс) и считывает данные со входов порта
  If SP_PortID()
    
    DSR=SP_GetControlPin(#SP_Pin_DSR)
    CTS=SP_GetControlPin(#SP_Pin_CTS)
    DCD=SP_GetControlPin(#SP_Pin_DCD)
    RI=SP_GetControlPin(#SP_Pin_RI)  
    
    SetGadgetText(5,Str(DSR))
    SetGadgetText(6,Str(CTS))
    SetGadgetText(10,Str(DCD))
    SetGadgetText(15,Str(RI))
    
    If Com(1)<>DSR
      Com(1)=DSR
      SetGadgetColor(5,#PB_Gadget_BackColor,RGB(238, 0, 0) )
    Else
      SetGadgetColor(5,#PB_Gadget_BackColor,RGB(225, 225, 225) )
    EndIf
    
    If Com(2)<>CTS
      Com(2)=CTS
      SetGadgetColor(6,#PB_Gadget_BackColor,RGB(238, 0, 0) )
    Else
      SetGadgetColor(6,#PB_Gadget_BackColor,RGB(225, 225, 225) )
    EndIf
    
    If Com(3)<>DCD
      Com(3)=DCD
      SetGadgetColor(10,#PB_Gadget_BackColor,RGB(238, 0, 0) )
    Else
      SetGadgetColor(10,#PB_Gadget_BackColor,RGB(225, 225, 225) )
    EndIf
    
    If Com(4)<>RI
      Com(4)=RI
      SetGadgetColor(15,#PB_Gadget_BackColor,RGB(238, 0, 0) )
    Else
      SetGadgetColor(15,#PB_Gadget_BackColor,RGB(225, 225, 225) )
    EndIf
    
  EndIf
EndProcedure

Procedure SelectPort(Port.s) ; Открывает порт.
  
  If IsSerialPort(2)
    CloseSerialPort(2)
  EndIf
  
  If OW_OpenPort(Port)
    ResizeGadget(2, #PB_Ignore, 20, #PB_Ignore, 15)
    SetGadgetText(2,"Порт открыт")
    SetGadgetColor(2,#PB_Gadget_FrontColor,RGB(12, 2, 202))
    SP_SetControlPin(#SP_Pin_DTR, GetGadgetState(3))
    SP_SetControlPin(#SP_Pin_RTS, GetGadgetState(4))
    SP_SetControlPin(#SP_Pin_TXD, GetGadgetState(7))
    For i=3 To 17
      If IsGadget(i)
        DisableGadget(i, 0)
      EndIf
    Next i
    
  Else
    ResizeGadget(2, #PB_Ignore, 10, #PB_Ignore, 40)
    SetGadgetText(2,"Ошибка! Возможно порт занят другой программой или отсутствует")
    SetGadgetColor(2,#PB_Gadget_FrontColor,RGB(253, 4, 2))
    For i=3 To 17
      If IsGadget(i)
        DisableGadget(i, 1)
      EndIf
    Next i
  EndIf
EndProcedure

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
    #Lib_Name = "OWire_Module.dll"
  CompilerElse
    #Lib_Name = "OWire_Module_x64.dll"
  CompilerEndIf
  
CompilerElseIf #PB_Compiler_OS = #PB_OS_Linux
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
    #Lib_Name = "OWire_Module.so"
  CompilerElse
    #Lib_Name = "OWire_Module_x64.so"
  CompilerEndIf
  
CompilerEndIf

If OW_Init(GetPathPart(ProgramFilename())+#Lib_Name)=#False
  MessageRequester("", "Ошибка при загрузке "+#Lib_Name)
  End
EndIf

OW_SetMode(#OW_Mode_NoControlPin)

If OpenWindow(0, 224, 34, 340, 122, "ComTest (OWire_Module.dll)",  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered | #PB_Window_Invisible )
  TextGadget(0, 20, 20, 30, 15, "Порт")
  ComboBoxGadget(1, 61, 16, 80, 20)
  For i=0 To 10
    AddGadgetItem(1,-1,"/dev/ttyS"+Str(i))
  Next i
  SetGadgetState(1,0)
  GadgetToolTip(1,"Выберите порт их списка")
  TextGadget(2, 150, 20, 185, 40, "" )
  CheckBoxGadget(3, 20, 55, 45, 15, "DTR")
  GadgetToolTip(3,"Если галочка установлена, на выводе 4 порта, будет положительное напряжение")
  CheckBoxGadget(4, 20, 70, 45, 15, "RTS")
  GadgetToolTip(4,"Если галочка установлена, на выводе 7 порта, будет положительное напряжение")
  StringGadget(5, 80, 55, 20, 20, "",#PB_String_ReadOnly)
  GadgetToolTip(5,"Вывод 6")
  StringGadget(6, 80, 80, 20, 20, "",#PB_String_ReadOnly)
  GadgetToolTip(6,"Вывод 8")
  CheckBoxGadget(7, 20, 85, 40, 15, "TXD")
  GadgetToolTip(7,"Если галочка установлена, на выводе 3 порта, будет положительное напряжение")
  TextGadget(8, 109, 59, 30, 15, "DSR")
  TextGadget(9, 107, 84, 30, 15, "CTS")
  StringGadget(10, 160, 55, 20, 20, "",#PB_String_ReadOnly)
  GadgetToolTip(10,"Вывод 1")
  StringGadget(15, 160, 80, 20, 20, "",#PB_String_ReadOnly)
  GadgetToolTip(15,"Вывод 9")
  TextGadget(16, 190, 59, 30, 15, "DCD")
  TextGadget(17, 191, 84, 25, 15, "RI")
  Frame3DGadget(19,15,40,52,70,"Выходы")
  Frame3DGadget(20,75,40,150,70,"Входы")
  HideWindow(0,0) 
  
  AddWindowTimer(0, 0, 400)
  BindEvent(#PB_Event_Timer, @ComIn(), 0, 0)
  
  SelectPort(GetGadgetText(1))
  
  Repeat
    
    Event=WaitWindowEvent()
    Gadget=EventGadget()
    Type=EventType()
    
    If Event=#PB_Event_Gadget
      Select Gadget
        Case 1
          If Type=1 Or Type=#PB_EventType_Change
            SelectPort(GetGadgetText(1))
          EndIf
        Case 3
          SP_SetControlPin(#SP_Pin_DTR, GetGadgetState(3))
        Case 4
          SP_SetControlPin(#SP_Pin_RTS, GetGadgetState(4))
        Case 7
          SP_SetControlPin(#SP_Pin_TXD, GetGadgetState(7))
      EndSelect
    EndIf
    
    
  Until Event=#PB_Event_CloseWindow
  RemoveWindowTimer(0, 0)
EndIf

OW_End()

End
; IDE Options = PureBasic 5.22 LTS (Linux - x64)
; CursorPosition = 96
; FirstLine = 72
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = Res\.ico
; Executable = ../ComTest
; IncludeVersionInfo
; VersionField0 = 1.2.0.0
; VersionField1 = 1.2.0.0
; VersionField3 =  COM .
; VersionField4 = 1.2
; VersionField5 = 1.2
; VersionField6 =  COM .
; VersionField7 = COM
; VersionField8 = ComTest.exe
; VersionField9 = ϸ
; VersionField15 = VOS_NT_WINDOWS32
; VersionField16 = VFT_APP
; VersionField17 = 0419 Russian